//usingfBNeBuŖOԂ̎QƂȒPɂ܂B
using System;
using System.Drawing;
using System.Windows.Forms;
using Wakaba;

namespace Game
{
    class Game
    {
        private const int STAR_SPEED = 8;
        private const float STAR_ZOOM = 0.5F;
        private const int STAR_ROLL = 4;
        private const int STAR_TRANSPARENT = 4;

        //IuWFNgϐ錾܂B
        private static Helper w;

        [STAThread]
        static void Main(string[] args)
        {
            try
            {
                int intX = 288;
                int intY = 208;
                float sngZoom = 1.0f;
                int intRoll =0;
                byte bytTransparent = 255;
                
                //IuWFNgϐCX^X܂B
                w = new Helper();

                //twp[܂B
                w.Initialize();

                w.SpriteCreate("wi", MyGame1.Properties.Resources.wall, Helper.TransparentColor.None);
                w.SpritePosition("wi", 3, 0, 0);
                w.SpriteShow("wi");

                w.SpriteCreate("", MyGame1.Properties.Resources.star, Helper.TransparentColor.Blue);
                w.SpriteShow("");

                //EBhE܂ŉʂXV܂B
                do
                {

                    switch (w.JoyPadDirection(0))
                    {
                        case (int)Helper.Direction.Down:
                            intY += STAR_SPEED;
                            break;
                        case (int)Helper.Direction.Left:
                            intX -= STAR_SPEED;
                            break;
                        case (int)Helper.Direction.LeftDown:
                            intX -= STAR_SPEED;
                            intY += STAR_SPEED;
                            break;
                        case (int)Helper.Direction.LeftUp:
                            intX -= STAR_SPEED;
                            intY -= STAR_SPEED;
                            break;
                        case (int)Helper.Direction.Right:
                            intX += STAR_SPEED;
                            break;
                        case (int)Helper.Direction.RightDown:
                            intX += STAR_SPEED;
                            intY += STAR_SPEED;
                            break;
                        case (int)Helper.Direction.RightUp:
                            intX += STAR_SPEED;
                            intY -= STAR_SPEED;
                            break;
                        case (int)Helper.Direction.Up:
                            intY -= STAR_SPEED;
                            break;
                    }

                    w.SpritePosition("", 2, intX, intY);

                    byte[] bytButtons = w.JoyPushButton(0);

                    if (bytButtons[0] != 0)
                    {
                        sngZoom += STAR_ZOOM;
                    }

                    if (bytButtons[1] != 0)
                    {
                        sngZoom -= STAR_ZOOM;
                    }

                    w.SpriteScale("", sngZoom);

                    if (bytButtons[2] != 0)
                    {
                        intRoll += STAR_ROLL;
                    }

                    if (bytButtons[3] != 0)
                    {
                        intRoll -= STAR_ROLL;
                    }

                    w.SpriteRotation("", intRoll);

                    if (bytButtons[4] != 0)
                    {
                        if ((int)bytTransparent - STAR_TRANSPARENT < 0)
                        {
                            bytTransparent = 0;
                        }
                        else
                        {
                            bytTransparent -= STAR_TRANSPARENT;
                        }
                    }

                    if (bytButtons[5] != 0)
                    {
                        if ((int)bytTransparent + STAR_TRANSPARENT > byte.MaxValue)
                        {
                            bytTransparent = byte.MaxValue;
                        }
                        else
                        {
                            bytTransparent += STAR_TRANSPARENT;
                        }
                    }

                    w.SpriteTransparent("", bytTransparent);

                    w.ScreenRefresh(true);
                }

                while (!w.WindowClosing);

            }
            catch (Exception ex)
            {
                //G[bZ[W\܂B
                MessageBox.Show(ex.Message + ex.StackTrace);
            }

            //twp[̃IuWFNgj܂B
            w.Dispose();
        }
    }
}